// GamePointInfoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GamePointInfo.h"
#include "GamePointInfoDlg.h"
#include <afxtempl.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using namespace boost;
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGamePointInfoDlg dialog

CGamePointInfoDlg::CGamePointInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGamePointInfoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGamePointInfoDlg)
	
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);


}

void CGamePointInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGamePointInfoDlg)
	DDX_Control(pDX, IDC_EDIT2, m_editInfo);
	DDX_Control(pDX, IDC_EDIT1, m_editPath);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGamePointInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CGamePointInfoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_BN_CLICKED(IDC_GETINFO, OnGetinfo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGamePointInfoDlg message handlers

BOOL CGamePointInfoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_editPath.SetFocus();
	
	
	CStdioFile file;
	CFileException e;
	CString sfilename;
	CString stopWord;
	char buffer[256];	

	
	int len = ::GetModuleFileName(::GetModuleHandle(AfxGetApp()->m_pszExeName),buffer,256);
	if (len > 0 ) 
	{
		sfilename = buffer;
		sfilename= sfilename.Left(sfilename.ReverseFind('\\') + 1);
		TRACE("  m_csExeRootpath=%s\n", (const char *)sfilename);
	}
	else 
		AfxMessageBox("Failed to get module .exe path.",MB_ICONINFORMATION);

	sfilename+="stopwords.dat";



	if( !file.Open( sfilename, CFile::modeRead, &e ) )
   {
		#ifdef _DEBUG
			afxDump << "File could not be opened " << e.m_cause << "\n";
		#endif
   }

	while(file.ReadString(stopWord))
	{
		m_strStopWordArray.Add(stopWord);

	}
	file.Close();
	/*m_strStopWordArray.Add("Monday");
	m_strStopWordArray.Add("Tuesday");
	m_strStopWordArray.Add("Wednesday");
	m_strStopWordArray.Add("Thursday");
	m_strStopWordArray.Add("Friday");
	m_strStopWordArray.Add("Saturday");
	m_strStopWordArray.Add("Sunday");
	m_strStopWordArray.Add("Champions");
	m_strStopWordArray.Add("League");
	m_strStopWordArray.Add("Cup");
	m_strStopWordArray.Add("Defending");
	m_strStopWordArray.Add("Halftime");
	m_strStopWordArray.Add("Eastern");
	m_strStopWordArray.Add("Conference");
	m_strStopWordArray.Add("David");
	m_strStopWordArray.Add("Robinson");
	m_strStopWordArray.Add("Western");
	m_strStopWordArray.Add("Bell");*/






	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGamePointInfoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGamePointInfoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGamePointInfoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CGamePointInfoDlg::OnBrowse() 
{
	// TODO: Add your control notification handler code here
	static char szFilter[] = "Text Files (*.txt)|*.txt||";
	CFileDialog fd(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,szFilter);
	if(fd.DoModal() == IDOK)
	{
		m_editPath.SetWindowText(fd.GetPathName());
	}
}

void CGamePointInfoDlg::OnGetinfo() 
{
	// TODO: Add your control notification handler code here
	CString tmpBuf;
	this->m_editPath.GetWindowText(tmpBuf);
	if(tmpBuf.IsEmpty())
	{
		MessageBox("Enter a filename before trying it.");
		return;
	}
	ParseFile(tmpBuf);
	
}







BOOL CGamePointInfoDlg::ParseFile(CString filename)
{
	if (filename.IsEmpty()){
		return FALSE;
	}
	CString finalstring;


	this->m_editInfo.SetWindowText("");

	CStdioFile file;
	CString inString = "";
	CString wholeFileString = "";
	std::string wholeFileStr = "";


	try{
		if (file.Open(filename,CFile::modeRead | CFile::typeText, NULL))
		{
			while (file.ReadString(inString))
			{
				wholeFileString += (inString+'\n');
			}
			file.Close();
		}
	}
	catch (CFileException e)
	{
		MessageBox("The file " + filename + " could not be opened for reading", "File Open Failed", MB_ICONHAND|MB_ICONSTOP|MB_ICONERROR );
		return FALSE;
	}


	wholeFileStr = wholeFileString.GetBuffer(10);


	boost::RegEx expr("[^\\.,;\\r\\n]+\\d+\\s*[-]\\s*\\d+[^\\.,;\\r\\n]+", FALSE);


	std::vector<std::string> v;

	expr.Grep(v, wholeFileStr);


	
	CString tempString;
	for(int i = 0; i < v.size(); i++)
	{
	
		CString teams,score,winner;
		tempString="";
		std::string line = (std::string)v[i];		
		const char *buf = line.c_str();		
		tempString+="Related Statement: ";
		tempString+=buf;
		tempString += "\r\n";
		tempString += "Teams: ";
		
		if(!GetScore(buf,score)||!GetTeamName(buf, teams,score))
			continue;
		else
			winner=GetWinner(buf,score,teams);
	
		tempString += (teams+"\r\n");		
		tempString += "Score: ";
		tempString += score;
		tempString +=("\r\n"+winner);
		tempString += "\r\n\r\n";	
		
		finalstring+=tempString;
		
	}

		if(finalstring.GetLength()==0)
			finalstring="Sorry, no info could be found.";
	
		this->m_editInfo.SetWindowText(finalstring);

	return TRUE;

}


BOOL CGamePointInfoDlg::GetTeamName(const char *line, CString &teams,CString score)
{
	
	char* pattern = "([A-Z](\\S+|(\\S+\\s[A-Z]\\S+)|(\\S+\\s[A-Z]\\S+\\s[A-Z]\\S+)))";
	bool addVS=true;
	CStringArray nameArray;
	CString strLine(line);
	
	RegEx exp(pattern, FALSE);	
	std::vector<std::string> v;	
	exp.Grep(v, line);
	
	for(int i = 0; i < v.size(); i++)
	{
		
		std::string str = (std::string)v[i];
		const char *buf = str.c_str();
		CString temp(buf);
		temp.TrimLeft(" :");
		temp.TrimRight(" :");
		//delete game place
		if (strLine.Mid(strLine.Find(temp)-3,2).Compare("at")==0)
			continue;
		if (strLine.Mid(strLine.Find(temp)-3,2).Compare("in")==0)
			continue;
		
		bool bAdd=true;
		
		for(int j=0;j<m_strStopWordArray.GetSize();j++)
		{
			int n;
			if(temp.Compare(m_strStopWordArray[j].GetBuffer(10))==0)
			{
				bAdd=false;
				break;
				
			}
			else if(((temp.Compare(m_strStopWordArray[j].GetBuffer(10)))!=0)&&
				((n=temp.Find(m_strStopWordArray[j]))!=-1))
			{
				temp.Delete(n,m_strStopWordArray[j].GetLength());
			}	
		}	
		
		if(bAdd)
		{
			
			temp.TrimLeft(" :");
			temp.TrimRight(" :");
			if(temp.GetLength()!=0)
				nameArray.Add(temp);				
		}
	}
	
	

	if(nameArray.GetSize()==2)
	{
		if(nameArray[0].Compare(nameArray[1].GetBuffer(10))==0)
			return false;
		teams=nameArray[0]+" vs "+nameArray[1];
	}
	else if(nameArray.GetSize()>2)
	{
		score.TrimLeft(" :\r\n");
		score.TrimRight(" :\r\n");
		CArray<int,int> spaces;

		int n=strLine.Find(score);
		int scoreLength=score.GetLength();

		for(i=0;i<nameArray.GetSize();i++)
		{
			int m=strLine.Find(nameArray[i]);
			CString s;
			if(n>m)			
				s=strLine.Mid(m,n-m);			
			else if(n<m)
				s=strLine.Mid(n+scoreLength,m-n-scoreLength);
			spaces.Add(CountSpaces(s));
		}
		CString team1=nameArray[0];
		CString team2=nameArray[0];
		
		for(i=1;i<nameArray.GetSize();i++)
		{
			if(spaces[i]<spaces[i-1])
			{
				team1=nameArray[i];
				
				n=i;
			}

		}
		nameArray.RemoveAt(n);
		spaces.RemoveAt(n);
		for(i=1;i<nameArray.GetSize();i++)
		{
			if(spaces[i]<spaces[i-1])
			{
				team2=nameArray[i];
				
			}

		}
		if(team1.Compare(team2.GetBuffer(10))==0)
			return false;
		if(strLine.Find(team1)>strLine.Find(team2))
			teams=team2+" vs "+team1;
		else
			teams=team1+" vs "+team2;


	}
	else if(teams.Right(3)==_T("vs ")
		||teams.Left(4)==_T(" vs ")
		||teams.GetLength()==0)
		return false;
	

	return true;

	
	

}



BOOL CGamePointInfoDlg::GetScore(const char *line, CString &score)
{
	
	char* pattern = "\\d+\\s*[-]\\s*\\d+";
	
	RegEx exp(pattern, FALSE);
	
	std::vector<std::string> v;

	
	exp.Grep(v, line);
	
		
		std::string str = (std::string)v[0];
		
	
		const char *buf = str.c_str();
		
		score+=buf;	
		
	
	
		if(score.FindOneOf("0123456789-")==-1)
			return false;

	
	return true;


}

int CGamePointInfoDlg::CountSpaces(CString s)
{
	int start=0;
	int n=0;
	while((start=s.Find(' ',start)+1)!=0)
	{
		n++;
	}
	return n;

}

CString CGamePointInfoDlg::GetWinner(const char *line, CString score,CString teams)
{
	CString winner,team1,team2;
	int start=0;
	int score1,score2;
	
	team1=teams.Left(teams.Find(" vs "));
	team2=teams.Right(teams.GetLength()-teams.Find(" vs ")-4);
	
	while((start=score.Find(' ',start)+1)!=0)
	{
		score.Delete(start);
	}
	score1=atoi(score.Left(score.Find('-')));
	score2=atoi(score.Right(score.GetLength()-score.Find('-')-1));
	if (score1==score2)
		winner="Winner: Dogfall";
	else if(score1>score2)
		winner="Winner: "+team1;
	else
		winner="Winner: "+team2;
	

	


	
	
	
	return winner;

}
