// GamePointInfoDlg.h : header file
//

#if !defined(AFX_GAMEPOINTINFODLG_H__1E8CF3F8_3B41_44D0_826A_DCA906A90567__INCLUDED_)
#define AFX_GAMEPOINTINFODLG_H__1E8CF3F8_3B41_44D0_826A_DCA906A90567__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <boost/regex.hpp>
#include <string>
#include <vector>

/////////////////////////////////////////////////////////////////////////////
// CGamePointInfoDlg dialog

class CGamePointInfoDlg : public CDialog
{
// Construction
public:
	int CountSpaces(CString);
	CGamePointInfoDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CGamePointInfoDlg)
	enum { IDD = IDD_GAMEPOINTINFO_DIALOG };
	CEdit	m_editPath;
	CEdit	m_editInfo;
	
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGamePointInfoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CString GetWinner(const char *line, CString score,CString teams);
	BOOL GetTeamName(const char* line, CString &teams,CString score);
	BOOL GetScore(const char *line, CString &score);
	BOOL ParseFile(CString filename);

	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CGamePointInfoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnBrowse();
	afx_msg void OnGetinfo();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
		CStringArray m_strStopWordArray;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GAMEPOINTINFODLG_H__1E8CF3F8_3B41_44D0_826A_DCA906A90567__INCLUDED_)
